clear, clc, close all;

%parametry vymeniku

a=0.125; %vzdalenost mimobeznych os (J)
b=0.35; %vzdalenost zasunuteho vymeniku od osy (J)
r=0.21; %polomer vymeniku (J)
d=0.05; %prumer obrabeciho nastroje (J)
q03=0.125; %maximalni vysunuti (J)
l1=0.1; %delka kuzele obrabeciho nastroje (J')
l2=0.05; %delka obrabeciho nastroje (J')

%parametry pohybu

dt=0.05; % pro cisla tr, tv, tt musi plati t...=n...*2*dt, kde n... je prirozene cislo ; pro cisla tpr, tpv, tpt, tu musi plati t...=n...*dt, kde n... je prirozene cislo

tr=4; %cas otoceni ramu
tpr=0.4; %cas prechodu zrychleni u otaceni ramu
tv=2; %cas otoceni vymeniku o pi/2
tpv=0.2; %cas prechodu zrychleni u otaceni vymeniku
tt=3; %cas translace (vysunuti/zasunuti)
tpt=0.3; %cas prechodu zrychleni u translace
tu=0.25; %cas uvolneni/upnuti nastroje

%pohyby

%-----otoceni vymeniku o pi/2 zacatek
fiCel=pi/2;
T=tv;
tp=tpv;

alfam=fiCel/(-tp*T/2+T^2/4);

caspom=0:dt:tp;

fiI=alfam/(6*tp)*caspom.^3;

caspom=tp:dt:(T/2-tp);

fiII=alfam/2*caspom.^2-alfam*tp/2*caspom+alfam*tp^2/6;

caspom=(T/2-tp):dt:(T/2+tp);

fiIII=-alfam/(6*tp)*caspom.^3+T*alfam/(4*tp)*caspom.^2+alfam*T/2*caspom-alfam*tp*caspom-alfam*T^2/(8*tp)*caspom-alfam*T^2/8+alfam*T*tp/4+alfam*T^3/(48*tp);

caspom=(T/2+tp):dt:(T-tp);

fiIV=-alfam/2*caspom.^2-alfam*tp/2*caspom+T*alfam*caspom-alfam*tp^2/6-alfam*T^2/4;

caspom=(T-tp):dt:T;

fiV=alfam/(6*tp)*caspom.^3-T*alfam/(2*tp)*caspom.^2+alfam*T^2/(2*tp)*caspom-alfam*tp*T/2+alfam*T^2/4-alfam*T^3/(6*tp);


fiv=fiI;

for i=1:length(fiII)
    fiv(i+length(fiI)-1)=fiII(i);
end
for i=1:length(fiIII)
    fiv(i+length(fiI)+length(fiII)-2)=fiIII(i);
end
for i=1:length(fiIV)
    fiv(i+length(fiI)+length(fiII)+length(fiIII)-3)=fiIV(i);
end
for i=1:length(fiV)
    fiv(i+length(fiI)+length(fiII)+length(fiIII)+length(fiIV)-4)=fiV(i);
end
%-----otoceni vymeniku o pi/2 konec

%-----otoceni vymeniku o pi zacatek
fiCel=pi;
T=tv;
tp=tpv;

alfam=fiCel/(2*(-tp*T/2+T^2/4));

Tpi=2*(tp/2+(tp^2/4+fiCel/alfam)^0.5);

T=0;
while T<Tpi
    T=T+2*dt;
end

tvpi=T;

alfam=fiCel/(-tp*T/2+T^2/4);

caspom=0:dt:tp;

fiI=alfam/(6*tp)*caspom.^3;

caspom=tp:dt:(T/2-tp);

fiII=alfam/2*caspom.^2-alfam*tp/2*caspom+alfam*tp^2/6;

caspom=(T/2-tp):dt:(T/2+tp);

fiIII=-alfam/(6*tp)*caspom.^3+T*alfam/(4*tp)*caspom.^2+alfam*T/2*caspom-alfam*tp*caspom-alfam*T^2/(8*tp)*caspom-alfam*T^2/8+alfam*T*tp/4+alfam*T^3/(48*tp);

caspom=(T/2+tp):dt:(T-tp);

fiIV=-alfam/2*caspom.^2-alfam*tp/2*caspom+T*alfam*caspom-alfam*tp^2/6-alfam*T^2/4;

caspom=(T-tp):dt:T;

fiV=alfam/(6*tp)*caspom.^3-T*alfam/(2*tp)*caspom.^2+alfam*T^2/(2*tp)*caspom-alfam*tp*T/2+alfam*T^2/4-alfam*T^3/(6*tp);


fivpi=fiI;

for i=1:length(fiII)
    fivpi(i+length(fiI)-1)=fiII(i);
end
for i=1:length(fiIII)
    fivpi(i+length(fiI)+length(fiII)-2)=fiIII(i);
end
for i=1:length(fiIV)
    fivpi(i+length(fiI)+length(fiII)+length(fiIII)-3)=fiIV(i);
end
for i=1:length(fiV)
    fivpi(i+length(fiI)+length(fiII)+length(fiIII)+length(fiIV)-4)=fiV(i);
end
%-----otoceni vymeniku o pi konec

%-----vysunuti vymeniku o q03 zacatek
xCel=q03;
T=tt;
tp=tpt;

am=xCel/(-tp*T/2+T^2/4);

caspom=0:dt:tp;

xI=am/(6*tp)*caspom.^3;

caspom=tp:dt:(T/2-tp);

xII=am/2*caspom.^2-am*tp/2*caspom+am*tp^2/6;

caspom=(T/2-tp):dt:(T/2+tp);

xIII=-am/(6*tp)*caspom.^3+T*am/(4*tp)*caspom.^2+am*T/2*caspom-am*tp*caspom-am*T^2/(8*tp)*caspom-am*T^2/8+am*T*tp/4+am*T^3/(48*tp);

caspom=(T/2+tp):dt:(T-tp);

xIV=-am/2*caspom.^2-am*tp/2*caspom+T*am*caspom-am*tp^2/6-am*T^2/4;

caspom=(T-tp):dt:T;

xV=am/(6*tp)*caspom.^3-T*am/(2*tp)*caspom.^2+am*T^2/(2*tp)*caspom-am*tp*T/2+am*T^2/4-am*T^3/(6*tp);


xt=xI;

for i=1:length(xII)
    xt(i+length(xI)-1)=xII(i);
end
for i=1:length(xIII)
    xt(i+length(xI)+length(xII)-2)=xIII(i);
end
for i=1:length(xIV)
    xt(i+length(xI)+length(xII)+length(xIII)-3)=xIV(i);
end
for i=1:length(xV)
    xt(i+length(xI)+length(xII)+length(xIII)+length(xIV)-4)=xV(i);
end
%-----vysunuti vymeniku o q03 konec

%-----vysunuti vymeniku o q03  za cas tr zacatek
xCel=q03;
T=tr;
tp=tpt;

am=xCel/(-tp*T/2+T^2/4);

caspom=0:dt:tp;

xI=am/(6*tp)*caspom.^3;

caspom=tp:dt:(T/2-tp);

xII=am/2*caspom.^2-am*tp/2*caspom+am*tp^2/6;

caspom=(T/2-tp):dt:(T/2+tp);

xIII=-am/(6*tp)*caspom.^3+T*am/(4*tp)*caspom.^2+am*T/2*caspom-am*tp*caspom-am*T^2/(8*tp)*caspom-am*T^2/8+am*T*tp/4+am*T^3/(48*tp);

caspom=(T/2+tp):dt:(T-tp);

xIV=-am/2*caspom.^2-am*tp/2*caspom+T*am*caspom-am*tp^2/6-am*T^2/4;

caspom=(T-tp):dt:T;

xV=am/(6*tp)*caspom.^3-T*am/(2*tp)*caspom.^2+am*T^2/(2*tp)*caspom-am*tp*T/2+am*T^2/4-am*T^3/(6*tp);


xttr=xI;

for i=1:length(xII)
    xttr(i+length(xI)-1)=xII(i);
end
for i=1:length(xIII)
    xttr(i+length(xI)+length(xII)-2)=xIII(i);
end
for i=1:length(xIV)
    xttr(i+length(xI)+length(xII)+length(xIII)-3)=xIV(i);
end
for i=1:length(xV)
    xttr(i+length(xI)+length(xII)+length(xIII)+length(xIV)-4)=xV(i);
end
%-----vysunuti vymeniku o q03 za cas tr konec

%-----otoceni ramu o pi/2 zacatek
fiCel=pi/2;
T=tr;
tp=tpr;

alfam=fiCel/(-tp*T/2+T^2/4);

caspom=0:dt:tp;

fiI=0;
fiII=0;
fiIII=0;
fiIV=0;
fiV=0;

fiI=alfam/(6*tp)*caspom.^3;

caspom=tp:dt:(T/2-tp);

fiII=alfam/2*caspom.^2-alfam*tp/2*caspom+alfam*tp^2/6;

caspom=(T/2-tp):dt:(T/2+tp);

fiIII=-alfam/(6*tp)*caspom.^3+T*alfam/(4*tp)*caspom.^2+alfam*T/2*caspom-alfam*tp*caspom-alfam*T^2/(8*tp)*caspom-alfam*T^2/8+alfam*T*tp/4+alfam*T^3/(48*tp);

caspom=(T/2+tp):dt:(T-tp);

fiIV=-alfam/2*caspom.^2-alfam*tp/2*caspom+T*alfam*caspom-alfam*tp^2/6-alfam*T^2/4;

caspom=(T-tp):dt:T;

fiV=alfam/(6*tp)*caspom.^3-T*alfam/(2*tp)*caspom.^2+alfam*T^2/(2*tp)*caspom-alfam*tp*T/2+alfam*T^2/4-alfam*T^3/(6*tp);


fir=fiI;

for i=1:length(fiII)
    fir(i+length(fiI)-1)=fiII(i);
end
for i=1:length(fiIII)
    fir(i+length(fiI)+length(fiII)-2)=fiIII(i);
end
for i=1:length(fiIV)
    fir(i+length(fiI)+length(fiII)+length(fiIII)-3)=fiIV(i);
end
for i=1:length(fiV)
    fir(i+length(fiI)+length(fiII)+length(fiIII)+length(fiIV)-4)=fiV(i);
end
%-----otoceni ramu o pi/2 konec

To=4*tu+4*tv+tvpi+2*tr+4*tt; %cas jedne otacky vacek

for i=1:To/dt %sestaveni vektoru prubehu natoceni ramu v case pro celou otacku vacky
    fi1(i)=0;
end
for i=(1.5*tv+tu+tt)/dt:(1.5*tv+tu+tt+tr)/dt
    fi1(i)=fir(i-(1.5*tv+tu+tt)/dt+1);
end
for i=(1.5*tv+tu+tt+tr)/dt:(To-1.5*tv-tu-tt-tr)/dt
    fi1(i)=pi/2;
end
for i=(To-1.5*tv-tu-tt-tr)/dt:(To-1.5*tv-tu-tt)/dt
    fi1(i)=pi/2-fir(i-(To-1.5*tv-tu-tt-tr)/dt+1);
end

for i=1:To/dt %sestaveni vektoru prubehu natoceni koncoveho efektoru vymeniku v case pro celou otacku vacky
    fi2(i)=0;
end
for i=1:tv/dt
    fi2(i)=fiv(i);
end
for i=tv/dt:(tv+tu+tt)/dt
    fi2(i)=pi/2;
end
for i=(tv+tu+tt)/dt:(2*tv+tu+tt)/dt
    fi2(i)=pi/2-fiv(i-(tv+tu+tt)/dt+1);
end
for i=(tv+tu+tt+tr)/dt:(2*tv+tu+tt+tr)/dt
    fi2(i)=-fiv(i-(tv+tu+tt+tr)/dt+1);
end
for i=(2*tv+tu+tt+tr)/dt:(2*tv+2*tu+2*tt+tr)/dt
    fi2(i)=-pi/2;
end
for i=(2*tv+2*tu+2*tt+tr)/dt:(2*tv+2*tu+2*tt+tr+tvpi)/dt
    fi2(i)=-pi/2+fivpi(i-(2*tv+2*tu+2*tt+tr)/dt+1);
end
for i=(2*tv+2*tu+2*tt+tr+tvpi)/dt:(To-2*tv-tu-tt-tr)/dt
    fi2(i)=pi/2;
end
for i=(To-2*tv-tu-tt-tr)/dt:(To-tv-tu-tt-tr)/dt
    fi2(i)=pi/2-fiv(i-(To-2*tv-tu-tt-tr)/dt+1);
end
for i=(To-2*tv-tu-tt)/dt:(To-tv-tu-tt)/dt
    fi2(i)=-fiv(i-(To-2*tv-tu-tt)/dt+1);
end
for i=(To-tv-tu-tt)/dt:(To-tv)/dt
    fi2(i)=-pi/2;
end
for i=(To-tv)/dt:(To)/dt
    fi2(i)=-pi/2+fiv(i-(To-tv)/dt+1);
end

for i=1:To/dt %sestaveni vektoru prubehu poloh vysunuti koncoveho efektoru vymeniku v case pro celou otacku vacky
    x3(i)=0;
end
for i=(tv+tu)/dt:(tv+tu+tt)/dt
    x3(i)=xt(i-(tv+tu)/dt+1);
end
for i=(tv+tu+tt)/dt:(1.5*tv+tu+tt)/dt
    x3(i)=q03;
end
for i=(1.5*tv+tu+tt)/dt:(1.5*tv+tu+tt+tr)/dt
    x3(i)=q03-xttr(i-(1.5*tv+tu+tt)/dt+1);
end
for i=(2*tv+2*tu+tt+tr)/dt:(2*tv+2*tu+2*tt+tr)/dt
    x3(i)=xt(i-(2*tv+2*tu+tt+tr)/dt+1);
end
for i=(2*tv+2*tu+2*tt+tr)/dt:(2*tv+2*tu+2*tt+tr+tvpi)/dt
    x3(i)=q03;
end
for i=(2*tv+2*tu+2*tt+tr+tvpi)/dt:(To-2*tv-2*tu-tt-tr)/dt
    x3(i)=q03-xt(i-(2*tv+2*tu+2*tt+tr+tvpi)/dt+1);
end
for i=(To-1.5*tv-tu-tt-tr)/dt:(To-1.5*tv-tu-tt)/dt
    x3(i)=xttr(i-(To-1.5*tv-tu-tt-tr)/dt+1);
end
for i=(To-1.5*tv-tu-tt)/dt:(To-tv-tu-tt)/dt
    x3(i)=q03;
end
for i=(To-tv-tu-tt)/dt:(To-tv-tu)/dt
    x3(i)=q03-xt(i-(To-tv-tu-tt)/dt+1);
end

%sestaveni pomocnych vektoru pro pohyby nastroju n1 a n2 ve vizualizaci

for i=1:To/dt
    fi1n1(i)=0;
end
for i=(1.5*tv+tu+tt)/dt:(1.5*tv+tu+tt+tr)/dt
    fi1n1(i)=fir(i-(1.5*tv+tu+tt)/dt+1);
end
for i=(1.5*tv+tu+tt+tr)/dt:(To)/dt
    fi1n1(i)=pi/2;
end

for i=1:To/dt
    fi2n1(i)=0;
end
for i=(tv+tu+tt)/dt:(2*tv+tu+tt)/dt
    fi2n1(i)=-fiv(i-(tv+tu+tt)/dt+1);
end
for i=(2*tv+tu+tt)/dt:(tv+tu+tt+tr)/dt
    fi2n1(i)=-pi/2;
end
for i=(tv+tu+tt+tr)/dt:(2*tv+tu+tt+tr)/dt
    fi2n1(i)=-pi/2-fiv(i-(tv+tu+tt+tr)/dt+1);
end
for i=(2*tv+tu+tt+tr)/dt:(2*tv+2*tu+2*tt+tr)/dt
    fi2n1(i)=-pi;
end
for i=(2*tv+2*tu+2*tt+tr)/dt:(2*tv+2*tu+2*tt+tr+tvpi)/dt
    fi2n1(i)=-pi+fivpi(i-(2*tv+2*tu+2*tt+tr)/dt+1);
end

for i=1:To/dt
    x3n1(i)=0;
end
for i=(tv+tu)/dt:(tv+tu+tt)/dt
    x3n1(i)=xt(i-(tv+tu)/dt+1);
end
for i=(tv+tu+tt)/dt:(1.5*tv+tu+tt)/dt
    x3n1(i)=q03;
end
for i=(1.5*tv+tu+tt)/dt:(1.5*tv+tu+tt+tr)/dt
    x3n1(i)=q03-xttr(i-(1.5*tv+tu+tt)/dt+1);
end
for i=(2*tv+2*tu+tt+tr)/dt:(2*tv+2*tu+2*tt+tr)/dt
    x3n1(i)=xt(i-(2*tv+2*tu+tt+tr)/dt+1);
end
for i=(2*tv+2*tu+2*tt+tr)/dt:(2*tv+2*tu+2*tt+tr+tvpi)/dt
    x3n1(i)=q03;
end
for i=(2*tv+2*tu+2*tt+tr+tvpi)/dt:(To-2*tv-2*tu-tt-tr)/dt
    x3n1(i)=q03-xt(i-(2*tv+2*tu+2*tt+tr+tvpi)/dt+1);
end

for i=1:To/dt
    fi1n2(i)=0;
end
for i=(To-1.5*tv-tu-tt-tr)/dt:(To-1.5*tv-tu-tt)/dt
    fi1n2(i)=fir(i-(To-1.5*tv-tu-tt-tr)/dt+1);
end
for i=(To-1.5*tv-tu-tt)/dt:(To)/dt
    fi1n2(i)=pi/2;
end

for i=1:To/dt
    fi2n2(i)=0;
end
for i=(2*tv+2*tu+2*tt+tr)/dt:(2*tv+2*tu+2*tt+tr+tvpi)/dt
    fi2n2(i)=fivpi(i-(2*tv+2*tu+2*tt+tr)/dt+1);
end
for i=(2*tv+2*tu+2*tt+tr+tvpi)/dt:(To-2*tv-tu-tt-tr)/dt
    fi2n2(i)=pi;
end
for i=(To-2*tv-tu-tt-tr)/dt:(To-tv-tu-tt-tr)/dt
    fi2n2(i)=pi-fiv(i-(To-2*tv-tu-tt-tr)/dt+1);
end
for i=(To-tv-tu-tt-tr)/dt:(To-2*tv-tu-tt)/dt
    fi2n2(i)=pi/2;
end
for i=(To-2*tv-tu-tt)/dt:(To-tv-tu-tt)/dt
    fi2n2(i)=pi/2-fiv(i-(To-2*tv-tu-tt)/dt+1);
end

for i=1:To/dt
    x3n2(i)=0;
end
for i=(2*tv+2*tu+tt+tr)/dt:(2*tv+2*tu+2*tt+tr)/dt
    x3n2(i)=xt(i-(2*tv+2*tu+tt+tr)/dt+1);
end
for i=(2*tv+2*tu+2*tt+tr)/dt:(2*tv+2*tu+2*tt+tr+tvpi)/dt
    x3n2(i)=q03;
end
for i=(2*tv+2*tu+2*tt+tr+tvpi)/dt:(To-2*tv-2*tu-tt-tr)/dt
    x3n2(i)=q03-xt(i-(2*tv+2*tu+2*tt+tr+tvpi)/dt+1);
end
for i=(To-1.5*tv-tu-tt-tr)/dt:(To-1.5*tv-tu-tt)/dt
    x3n2(i)=xttr(i-(To-1.5*tv-tu-tt-tr)/dt+1);
end
for i=(To-1.5*tv-tu-tt)/dt:(To-tv-tu-tt)/dt
    x3n2(i)=q03;
end
for i=(To-tv-tu-tt)/dt:(To-tv-tu)/dt
    x3n2(i)=q03-xt(i-(To-tv-tu-tt)/dt+1);
end

%konec sestaveni pomocnych vektoru pro pohyby nastroju n1 a n2 ve vizualizaci

%animace

sw=0;
start=1;
stop=2;
for j=1:To/dt

    q3=x3(j); %vysunuti 0 až q03

    q2=fi2(j); %natoceni vymeniku v radianech -pi/2 až pi/2

    q1=fi1(j); %natoceni ramu v radianech 0 až pi/2

    %posuny obrabecich nastroju
    q3n1=x3n1(j);
    q3n2=x3n2(j);
    q2n1=fi2n1(j);
    q2n2=fi2n2(j);
    q1n1=fi1n1(j);
    q1n2=fi1n2(j);

    xp=[-0.8, 0.8]; %prostor
    yp=[-0.8, 0.8];
    zp=[-0.8, 0.8];

    xo=[0.25, 0, 0, 0]; %osy
    yo=[0, 0, 0, b];
    zo=[0, 0, -a, -a];

    xv=[0, d/2,0, 0, d/2, 0]; %vymenik
    yv=[b+q3, b+q3, b+q3, b+q3, b+q3, b+q3];
    zv=[-a-r-d/2, -a-r, -a-r+d/2, -a+r-d/2, -a+r, -a+r+d/2];

    xt=[0, 0]; %tyc
    yt=[b+q3, -q03+q3];
    zt=[-a, -a];

    xn1=[-r, -r]; %obrabeci nastroj 1
    yn1=[b+q3n1-l1, b+q3n1+l2];
    zn1=[-a, -a];

    xn2=[-r, -r]; %obrabeci nastroj 2
    yn2=[-a, -a];
    zn2=[-b-q3n2+l1, -b-q3n2-l2];

    for i=1:length(xv)
        xvpom(i)=xv(i);
        xv(i)=xv(i)*cos(q2)+(zv(i)+a)*sin(q2);
        zv(i)=-xvpom(i)*sin(q2)+(zv(i)+a)*cos(q2)-a;
    end

    for i=1:length(xn1)
        xn1pom(i)=xn1(i);
        xn1(i)=xn1(i)*cos(q2n1)+(zn1(i)+a)*sin(q2n1);
        zn1(i)=-xn1pom(i)*sin(q2n1)+(zn1(i)+a)*cos(q2n1)-a;
    end

    for i=1:length(xn2)
        xn2pom(i)=xn2(i);
        xn2(i)=xn2(i)*cos(q2n2)+(yn2(i)+a)*sin(q2n2);
        yn2(i)=-xn2pom(i)*sin(q2n2)+(yn2(i)+a)*cos(q2n2)-a;
    end

    for i=1:length(xo)
        yopom(i)=yo(i);
        yo(i)=yo(i)*cos(q1)+zo(i)*sin(q1);
        zo(i)=-yopom(i)*sin(q1)+zo(i)*cos(q1);
    end

    for i=1:length(xv)
        yvpom(i)=yv(i);
        yv(i)=yv(i)*cos(q1)+zv(i)*sin(q1);
        zv(i)=-yvpom(i)*sin(q1)+zv(i)*cos(q1);
    end

    for i=1:length(xt)
        ytpom(i)=yt(i);
        yt(i)=yt(i)*cos(q1)+zt(i)*sin(q1);
        zt(i)=-ytpom(i)*sin(q1)+zt(i)*cos(q1);
    end

    for i=1:length(xn1)
        yn1pom(i)=yn1(i);
        yn1(i)=yn1(i)*cos(q1n1)+zn1(i)*sin(q1n1);
        zn1(i)=-yn1pom(i)*sin(q1n1)+zn1(i)*cos(q1n1);
    end

    for i=1:length(xn2)
        yn2pom(i)=yn2(i);
        yn2(i)=yn2(i)*cos(q1n2)-zn2(i)*sin(q1n2);
        zn2(i)=yn2pom(i)*sin(q1n2)+zn2(i)*cos(q1n2);
    end

    p=plot3(xp,yp,zp,'go',xo,yo,zo,'b',xv,yv,zv,'r',xt,yt,zt,'r',xn1,yn1,zn1,'k',xn2,yn2,zn2,'m');
    p(2).LineWidth=6;
    p(3).LineWidth=3;
    p(4).LineWidth=3;
    p(5).LineWidth=3;
    p(6).LineWidth=3;
    %p=plot3(xp,yp,zp,'go',xo,yo,zo,'b','linewidth',6,xv,yv,zv,'r','linewidth',3,xt,yt,zt,'r','linewidth',3,xn1,yn1,zn1,'k','linewidth',3,xn2,yn2,zn2,'m','linewidth',3); %pro octave
    view([-15 22.5]);
    grid on

    switch sw
    case 0
        sw=menu('','start','stop');
    case 1
    otherwise
    break
    end
    
    pause(dt);
end

rpom=0.1;
%parametry mechanismu (jsou vyznaceny na prilozenem obrazku)

i1=2774/134; % (j)
p1=0.75; % (j)
r1=(p1^2+rpom^2)^0.5; % (j)
%fi01=0.171; % (j)
fi01=0.237; % (j)

i2=108/33; % (j)
p21=0.115; % (j)
p22=1.4; % (j)
p23=0.75; % (j)
o21=0.04; % (j)
o22=0.03; % (j)
r2=(p23^2+rpom^2)^0.5; % (j)
fi021=0.09146; % (j)
fi022=0.0087266; % (j)
%fi023=0.208; % (j)
fi023=0.198; % (j)
d21=a-0.018; % (j)
d22=1.3995; % (j)

i3=2824/84; % (j)
p31=0.135; % (j)
p32=0.75; % (j)
o3=0.05; % (j)
r3=(p32^2+rpom^2)^0.5; % (j)
fi031=0.56077; % (j)
%fi032=0.2; % (j)
fi032=0.208; % (j)
d3=a; % (j)

%pocitani tvaru vacek

%___vacka jedna, zacatek

np1=-fi1/i1+fi01; %prubeh natoceni paky zapadajici do drazky vacky

for i=1:length(np1)
    rv1(i)=(p1^2+r1^2-2*p1*r1*cos(np1(i)))^0.5;
    fipom11(i)=acos(p1*sin(np1(i))/rv1(i));
end

for i=1:length(fipom11)
    fipom12(i)=fipom11(i)+(i-1)*2*pi*dt/To;
end

vx1=rv1.*cos(fipom12); %x-ové souřadnice bodů zobrazujicich tvar drazky vacky
vy1=rv1.*sin(fipom12); %y-ové souřadnice bodů zobrazujicich tvar drazky vacky

%___vacka jedna, konec

%___vacka dva, zacatek

fi21=-fi2/i2+fi021;

x021=-p21*sin(fi021)+(p21^2*(sin(fi021))^2+o21^2-d21^2-p21^2+2*p21*d21*cos(fi021))^0.5;

for i=1:length(fi21)
    x2(i)=-p21*sin(fi21(i))+(p21^2*(sin(fi21(i)))^2+o21^2-d21^2-p21^2+2*p21*d21*cos(fi21(i)))^0.5-x021;
end

x022=-p22*sin(fi022)+(p22^2*(sin(fi022))^2+o22^2-d22^2-p22^2+2*p22*d22*cos(fi022))^0.5;

for i=1:length(x2)
    fi22(i)=acos((o22^2-d22^2-(x022+x2(i))^2-p22^2)/(-2*(d22^2+(x022+x2(i))^2)^0.5*p22))-atan((x022+x2(i))/d22);
end

np2=-fi22+fi022+fi023; %prubeh natoceni paky zapadajici do drazky vacky

for i=1:length(np2)
    rv2(i)=(p23^2+r2^2-2*p23*r2*cos(np2(i)))^0.5;
    fipom21(i)=acos(p23*sin(np2(i))/rv2(i));
end

for i=1:length(fipom21)
    fipom22(i)=fipom21(i)+(i-1)*2*pi*dt/To;
end

vx2=rv2.*cos(fipom22); %x-ové souřadnice bodů zobrazujicich tvar drazky vacky
vy2=rv2.*sin(fipom22); %y-ové souřadnice bodů zobrazujicich tvar drazky vacky

%___vacka dva, konec

%___vacka tri, zacatek

x03=p31*sin(fi031)-(p31^2*(sin(fi031))^2+o3^2-d3^2-p31^2+2*p31*d3*cos(fi031))^0.5;

for i=1:length(x3)
    fi31(i)=acos((o3^2-d3^2-(x03-x3(i))^2-p31^2)/(-2*(d3^2+(x03-x3(i))^2)^0.5*p31))+atan((x03-x3(i))/d3);
end

fi32=fi31-fi031+fi1;

np3=-fi32/i3+fi032; %prubeh natoceni paky zapadajici do drazky vacky

for i=1:length(np3)
    rv3(i)=(p32^2+r3^2-2*p32*r3*cos(np3(i)))^0.5;
    fipom31(i)=acos(p32*sin(np3(i))/rv3(i));
end

for i=1:length(fipom31)
    fipom32(i)=fipom31(i)+(i-1)*2*pi*dt/To;
end

vx3=rv3.*cos(fipom32); %x-ové souřadnice bodů zobrazujicich tvar drazky vacky
vy3=rv3.*sin(fipom32); %y-ové souřadnice bodů zobrazujicich tvar drazky vacky

%___vacka tri, konec

pause(2);

%tvar drazek vacek

st=0:2*pi/360:2*pi;
kr1x=0.025*cos(st);
kr1y=0.025*sin(st);
kr2x=0.2*cos(st);
kr2y=0.2*sin(st);
kr3x=rpom*cos(st);
kr3y=rpom*sin(st);

figure(2)
plot(vx1,vy1,'y','LineWidth',5) %vykresleni vacky 1
hold on
plot(vx2,vy2,'g','LineWidth',3) %vykresleni vacky 2
plot(vx3,vy3,'b','LineWidth',1) %vykresleni vacky 3
plot(kr1x,kr1y)
plot(kr2x,kr2y)
plot(kr3x,kr3y)
xlabel('[m]')
ylabel('[m]')
legend('vacka 1','vacka 2','vacka 3')

%posunuti a natoceni ramene vymeniku

xpom=linspace(0,1,To/dt);

figure(3)
subplot(3,1,1)
plot(xpom,fi2,'LineWidth',2)
title('otaceni ramene vymeniku vuci otocnemu ramu')
axis([0 1 -2 2])
ylabel('fi2 [rad]')
subplot(3,1,2)
plot(xpom,x3,'LineWidth',2)
title('vysouvani ramene vymeniku z otocneho ramu')
axis([0 1 0 0.15])
ylabel('x3 [m]')
subplot(3,1,3)
plot(xpom,fi1,'LineWidth',2)
title('otaceni otocneho ramu')
axis([0 1 0 1.75])
xlabel('t [cas jedne otacky vacek]')
ylabel('fi1 [rad]')

%natoceni pak

figure(4)
subplot(3,1,1)
plot(xpom,np2,'LineWidth',2)
title('natoceni paky 2')
axis([0 1 0.15 0.25])
ylabel('np2 [rad]')
subplot(3,1,2)
plot(xpom,np3,'LineWidth',2)
title('natoceni paky 3')
axis([0 1 0.15 0.25])
ylabel('np3 [rad]')
subplot(3,1,3)
plot(xpom,np1,'LineWidth',2)
title('natoceni paky 1')
axis([0 1 0.15 0.25])
xlabel('t [cas jedne otacky vacek]')
ylabel('np1 [rad]')

%export dat

vx1exp=vx1*1000;
vy1exp=vy1*1000;
vx2exp=vx2*1000;
vy2exp=vy2*1000;
vx3exp=vx3*1000;
vy3exp=vy3*1000;

lpom=0;
while lpom<(length(vx1exp)/2)
    lpom=lpom+1;
end
lpom=length(vx1exp)-lpom;

data1=zeros(lpom,3);
for i=1:lpom
data1(i,1)=vx1exp(1+2*(i-1));
data1(i,2)=vy1exp(1+2*(i-1));
end

data2=zeros(lpom,3);
for i=1:lpom
data2(i,1)=vx2exp(1+2*(i-1));
data2(i,2)=vy2exp(1+2*(i-1));
end

data3=zeros(lpom,3);
for i=1:lpom
data3(i,1)=vx3exp(1+2*(i-1));
data3(i,2)=vy3exp(1+2*(i-1));
end
